/******************************************************************************\
**
**     COMPANY:	LDW Software
**
**      MODULE:	Blowing Leaves
**
** DESCRIPTION:	Manages Blowing Leaves
**
**
\******************************************************************************/

#ifndef BLOWING_LEAVES_H
#define BLOWING_LEAVES_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/

#include "ldwImage.h"

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class CBlowingLeaves 
{
public:

	CBlowingLeaves();
	~CBlowingLeaves();

	void Reset();

	void Update();
	void Draw();

	void ClickPoint(ldwPoint pos);

private:

	enum
	{
		eMaxWindStrength = 10,
	};

	bool  mWindBlowing;
	bool  mWindWasBlowing;
	bool  mWindIsStopping;
	int   mWindSpeed;
	int   mCurrentWindStrength;
	float mWindOcillationAngle;
	float mWindOcillationIncrement;
	int   mPeakWindStrength;

	ldwImageGrid *	m_pLeaves;
};

/******************************************************************************\
** GLOBAL DECLARATIONS
\******************************************************************************/
extern CBlowingLeaves BlowingLeaves;

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/
