/******************************************************************************\
**
**     COMPANY:	LDW Software
**
**      MODULE:	Bath 
**
** DESCRIPTION:	Bath Restoration Puzzle
**
**      AUTHOR:	Arthur Humphrey, from template of Adrian Francis
**
\******************************************************************************/

#ifndef ConvertMasterDoctorPUZZLE_H
#define ConvertMasterDoctorPUZZLE_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/
#include "ldwImage.h"
#include "PuzzleInterface.h"
#include "../Game/theGameState.h"

/******************************************************************************\
** CONSTANT DEFINITIONS
\******************************************************************************/

//const ldwPoint Fruitwells_c_sCenter(114, 1802);

enum EConvertMasterDoctorStatus
{
	eConvertMasterDoctor_InitialState = 0,

	eConvertMasterDoctor_NumberOfStates

};

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class CConvertMasterDoctorPuzzle : public IPuzzle
{
	friend class CPuzzle;

public:

	CConvertMasterDoctorPuzzle(void);



	EConvertMasterDoctorStatus m_eConvertMasterDoctorStatus;

	void Reset();

	const int	LoadState(const unsigned char *pData);
	const int	SaveState(const unsigned char *pData, const int iMaxDataSize) const;
	bool		AdvancePuzzleState();
	EConvertMasterDoctorStatus	 GetStatus();
	int GetPercentComplete();

	void Draw() const;
	

	void		Draw(const int iRef);
	const int SaveStateSize() {return sizeof (SSaveState);}
	void		LoadAssets();
	void		ReleaseAssets();

	// process
	void Refresh();
	void Update();
	void Advance(CVillager &Villager, const int iRef);
	void Advance();
	void Complete();

	// access

private:
	

	//class structures
	struct SSaveState
	{
		//EConvertMasterDoctorStatus	m_eConvertMasterDoctorStatus;
	//	int					m_iConvertMasterDoctorProgress;
	};
	
	int m_iConvertMasterDoctorProgress;
	ldwImageGrid *  m_pNecklacePiece;
	//class data
	
	theGameState  *gs;
	bool diagProp;

};

/******************************************************************************\
** GLOBAL DECLARATIONS
\******************************************************************************/
extern CConvertMasterDoctorPuzzle		ConvertMasterDoctorPuzzle;

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/