/******************************************************************************\
**
**     COMPANY:	LDW Software
**
**      MODULE:	EditorInterface
**
** DESCRIPTION:	Interface for editor modules
**
**      AUTHOR:	Adrian Francis
**
\******************************************************************************/

#ifndef EDITOR_INTERFACE_H
#define EDITOR_INTERFACE_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/
#include "ldwTypes.h"
#include "ldwScene.h"

/******************************************************************************\
** CONSTANT DEFINITIONS
\******************************************************************************/

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class IEditor
{
public:
	//interface methods
	//setup
	virtual void Reset() = 0;

	// process

	virtual void Show(const bool bShow) {};
	virtual void Draw() = 0;
	virtual const bool HandleKeyCharacter(const char cKey) = 0;
	virtual const bool HandleKeyDown(const int iKeyCode) = 0;
	virtual const bool HandleKeyUp(const int iKeyCode) = 0;
	virtual const bool HandleMouseDown(const ldwPoint sMousePos) = 0;
	virtual const bool HandleMouseUp(const ldwPoint sMousePos) = 0;
	virtual const bool HandleMouseMove(const ldwPoint sMousePos) = 0;

	virtual bool ShowDecals() {return false;}

	// access
};

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/