/******************************************************************************\
**
**     COMPANY:	LDW Software
**
**      MODULE:	Bath 
**
** DESCRIPTION:	Bath Restoration Puzzle
**
**      AUTHOR:	Arthur Humphrey, from template of Adrian Francis
**
\******************************************************************************/

#ifndef HeathenMommyPUZZLE_H
#define HeathenMommyPUZZLE_H

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/
#include "ldwImage.h"
#include "PuzzleInterface.h"
#include "../Game/theGameState.h"

/******************************************************************************\
** CONSTANT DEFINITIONS
\******************************************************************************/

//const ldwPoint Fruitwells_c_sCenter(114, 1802);

enum EHeathenMommyStatus
{
	eHeathenMommy_InitialState = 0,
	eHeathenMommy_WorkStarted,
	eHeathenMommy_OneQuarterDown,
	eHeathenMommy_OneHalfDown,
	eHeathenMommy_ThreeQuartersDown,
	eHeathenMommy_TotemDown,
	eHeathenMommy_NumberOfStates

};

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class CHeathenMommyPuzzle : public IPuzzle
{
	friend class CPuzzle;

public:

	CHeathenMommyPuzzle(void);



	EHeathenMommyStatus m_eHeathenMommyStatus;

	void Reset();

	const int	LoadState(const unsigned char *pData);
	const int	SaveState(const unsigned char *pData, const int iMaxDataSize) const;
	bool		AdvancePuzzleState();
	EHeathenMommyStatus	 GetStatus();
	int GetPercentComplete();

	void Draw() const;
	

	void		Draw(const int iRef);
	const int SaveStateSize() {return sizeof (SSaveState);}
	void		LoadAssets();
	void		ReleaseAssets();

	// process
	void Refresh();
	void Update();
	void Advance(CVillager &Villager, const int iRef);
	void Advance();
	void AdvanceRebuild();
	void Complete();

	// access

private:
	

	//class structures
	struct SSaveState
	{
		EHeathenMommyStatus	m_eHeathenMommyStatus;
		int					m_iHeathenMommyProgress;
	};
	
	int m_iHeathenMommyProgress;

	ldwUINT32 m_uPlantTimer;
	//class data
	
	theGameState  *gs;

	ldwImageGrid *	m_pScaffold;

	ldwImageGrid *	m_pTotem;

};

/******************************************************************************\
** GLOBAL DECLARATIONS
\******************************************************************************/
extern CHeathenMommyPuzzle		HeathenMommyPuzzle;

#endif

/******************************************************************************\
** END OF FILE
\******************************************************************************/