////////////////////////////////////////////////////////////////////
//
//    DESCRIPTION:
//
//    AUTHOR:
//
//    HISTORY:
//
////////////////////////////////////////////////////////////////////

#ifndef ISLAND_EVENTS_HEADER
#define ISLAND_EVENTS_HEADER

#include "ldwTypes.h"
#include "../Game/theGameState.h"
enum IslandEventId
{
	eNoEvent = 0,

	eTheCreepingMoldEvent,
	eAllergySeasonEvent,
	eIsolaDayEvent,
	eDayOfHonorEvent,
	eTheVisionEvent,
	eMysteriousFogFoodBonusEvent,
	eMysteriousFogFoodPenaltyEvent,
	eMysteriousFogTechBonusEvent,
	eMysteriousFogTechPenaltyEvent,
	eBlessingsDayEvent,
	eTheBedBugsEvent,
	eTheMaskEvent,
	eTheHeathenToyEvent,
	eBunjeeJumpingEvent,
	eTheColdSnapEvent,
	eTheArmyAntsEvent,
	eTheAphidsEvent,
	eTheStrangeCrystalsEvent,
	eTheEspeciallyOffensiveCloudEvent,
	eTheBottleOfHotsauceEvent,
	eTheRiverBreaksItsBanksEvent,
	eTheClumbsyHeathenEvent,
	eThePeskyCritterEvent,
	eMushroomDayEvent,
	eTheStingingWaspsEvent,
	eBarrelOBabiesVEvent,
	eBarrelOHeathenBabiesVEvent,
	eTheSaltyAirEvent,
	eTheReturnOfBigglesEvent,
	eChutesWithoutLaddersEvent,
	eNewsFromAnotherTribe1Event,
	eNewsFromAnotherTribe2Event,
	eAbandonedInfantsEvent,
	eTheSpaEvent,
	eDoubtEvent,
	eSpyingOnTheHeathensEvent,
	eYoureDoinItWrongEvent,
	eTheMissingKidsEvent,
	eOutreachEvent,
	eTheAdvancedArtifactsEvent,
	eTrickOrTradeEvent,
	eTheMigratingFruitBatsEvent,
	eAphidsInTheHydrofarmEvent,
	eTheDefectorEvent,
	eTheStrawHatEvent,
	eTheStrangeNectarEvent,
	eTheCrackedMaskEvent,
	eTheSmellyVialEvent,
	eTheFloralVialEvent,
	eTheInvisibleVialEvent,
	eInnovationInFarmingEvent,
	eChildInTheTreeEvent,
	eThePrettyShellEvent,
	eBigglesPaysAVisitEvent,
	eMysteriousStorytellerEvent,


	eIslandEventCount
};

enum EventResourceId
{
	eResourceFood = 0,
	eResourceTech,
	eResourcePopulation,
	eResourceChildren,
	eResourceAdults,
	eResourceHoney,
	eResourceFruit,

	eNumResources
};
class CIslandEvent;
class ldwScene;

class CIslandEvents
{
public:

	static CIslandEvents *Get();
	static CIslandEvents &Ref();

	static void           Destroy();

	~CIslandEvents (); // class destructor

	bool IsTimeForAnEvent();

	bool FireEvent(ldwScene *parentScene);

	void ShowAll(ldwScene *parentScene);

	bool ForceEvent(ldwScene *parentScene,IslandEventId eventId);

	int PercentOfResource(int percent ,EventResourceId whichResource);

	int EventScalor(int prizeBaseAmount);

private:
	theGameState  *gs;
	CIslandEvents ();  // class constructor

	static CIslandEvents *mInstance;

	ldwUINT32 mLastEventTime;

 	static CIslandEvent *mEventList[eIslandEventCount];
	static bool			 mEventHasFired[eIslandEventCount];
};

#endif