/******************************************************************************\
**
**     COMPANY:	LDW Software
**
**      MODULE:	ldwDropDown
**
** DESCRIPTION:	Drop down menu
**
\******************************************************************************/

/******************************************************************************\
** LIBRARY INCLUDES
\******************************************************************************/
#include "ldwEventHandler.h"
#include "ldwFont.h"
#include "ldwTypes.h"

/******************************************************************************\
** CONSTANT DEFINITIONS
\******************************************************************************/
const int ldwDropDown_c_iScrollBarWidth = 20;
const int ldwDropDown_c_iScrollKnobWidth = 18;
const int ldwDropDown_c_iMinScrollKnobHeight = 8;

/******************************************************************************\
** CLASS DEFINITIONS
\******************************************************************************/
class ldwDropDown : public ldwEventHandler
{
private:

	ldwRect		m_sBounds;

	char **		m_psItemArray;
	int			m_iNumItems;

	ldwPoint	m_sPos;
	int			m_iLongestItem;

	int			m_iHighLightedItem;
	int			m_iSelectedItem;
	bool		m_bShowList;
	bool		m_bRefreshList;

	bool		m_bIsMouseDown;

	bool		m_bDragScrollKnob;
	bool		m_bDragScrollWindow;
	int			m_iDragY;
	int			m_iScrollPos;

	ldwRect		m_sScrollWindowRect;
	ldwRect		m_sScrollBarRect;
	ldwRect		m_sScrollKnobRect;
	int			m_iScrollAreaHeight;
	int			m_iScrollableHeight;
	int			m_iScrollKnobMaxY;

public:

	ldwDropDown(const char **psItemArray, const int iNumItems);
	~ldwDropDown();

	void Draw(const ldwPoint sPos, const int iWidth, const ldwColor textColor, ldwFont *font);;

	bool HandleMouse(int messageId,ldwPoint location);

	void SetSelection(const int iSelection);
	const int GetSelection(void) const;

	const bool IsListShown(void) const;
};

/******************************************************************************\
** END OF FILE
\******************************************************************************/