//
//		Definition of the Graphics Manager class
//
//
#ifndef THE_GRAPHICS_MANAGER_H
#define THE_GRAPHICS_MANAGER_H

#include "ldwImage.h"
#include "ldwTiledBackground.h"
//
//
//	UI Color constants

const ldwColor UI_ButtonUpColor(0,0,0);
const ldwColor UI_ButtonOverColor(0x55,0x55,0x55);
const ldwColor UI_ButtonDownColor(0x55,0x55,0x55);
const ldwColor UI_LabelColor(0x45,0x22,00);

const ldwPoint UI_HandCursorHotSpot(21,24);
//

enum EImageType
{
	eImageType_None = -1,

	eImageType_Image,
	eImageType_Strip,
	eImageType_Grid,
};

enum EImage
{
	eImage_None = 0,
	eImage_OpenHand,
	eImage_Hand,
	eImage_SpellBacking,
	eImage_SpellLens,
	eImage_StomppedMushroom,
	eImage_SpellArea160,
	eImage_GodPowerIcons,
	eImage_Flowers,
	eImage_Willowisp1Strip,
	eImage_StatusBarSliceG,
	eImage_Totems,
	eImage_SmeltPotStrip,
	eImage_GoldBall,
	eImage_MausoleumDebrisStrip,
	eImage_FaithMeterBG,
	eImage_FirePlaceDecal,
	eImage_ManaBGBar,
	eImage_FaithGradientBar,
	eImage_FaithGradientArc,
	eImage_transportersparkles3Strip,
	eImage_lightningstripwhite,
	eImage_IdolCoverings,
	eImage_ResearchTotemStrip,
	eImage_BuildingTotemStrip,
	eImage_MedicineTotemStrip,
	eImage_FoodTotemStrip,
	eImage_ClosedEyeTotemStrip,
	eImage_ChildrensTotemStrip,
	eImage_HovelCoverDecal,
	eImage_RainbowTotemStrip,
	eImage_BlueDyeBucket,
	eImage_RedDyeBucket,
	eImage_YellowDyeBucket,
	eImage_TopPoolRed,
	eImage_TopPoolBlue,
	eImage_TopPoolYellow,
	eImage_TopPoolPurple,
	eImage_TopPoolGreen,
	eImage_TopPoolOrange,
	eImage_TopPoolBrown,
	eImage_ProofCompleteCrappy,
	eImage_ProofCompleteGood,
	eImage_ProofPartialCrappy,
	eImage_ProofPartialGood,
	eImage_ProofDisapprove,
	eImage_SafeZoneStrip,
	eImage_WilloWispStripSml2,
	eImage_BlinkyEyes,
	eImage_BlinkyEyesSm,
	eImage_RisingLightRays,
	eImage_BlowingLeaves,
	eImage_SunShafts,
	eImage_CloudPuff,
	eImage_DecalSmallCollectibles,
    eImage_Undertow1,
	eImage_WaveBreak1,
	eImage_FocusWindowMask,
	eImage_FocusWindowLens,
	eImage_CuttingTool,
	eImage_RuinsRubble,
	eImage_MausoleumBackground,
	eImage_MausoleumTopUI,	
	eImage_MausoleumBottomUI,	
	eImage_MausoleumRow,
	eImage_MausoleumKnobTop,
	eImage_MausoleumKnobMid,
	eImage_MausoleumKnobBtm,
	eImage_MausoleumScrollTrack,
	eImage_MausoleumUpArrow,		
	eImage_MausoleumDownArrow,
	eImage_MausoleumTint,		
	eImage_MausoleumUrn,
	eImage_HelpClick,
	eImage_HelpGrowth,
	eImage_HelpLabel_1,
	eImage_HelpLabel_2,
	eImage_HelpLabel_3,
	eImage_HelpLabel_4,
	eImage_Help_UI_BG,
	eImage_HelpSelectVillager,
	eImage_Fishpile1,
	eImage_btnCollectionsDone,
	eImage_DetailSceneLeftButton,
	eImage_DetailSceneRightButton,
	eImage_HelpSceneLeftButton,
	eImage_HelpSceneRightButton,
	eImage_btnDone,
	eImage_HelpCreditsButton,
	eImage_AdoptBackground,
	eImage_Blackberry,
	eImage_CrawlingCrab1,
	eImage_CrawlingCrab2,
	eImage_TechCarving1,
	eImage_TechCarving2,
	eImage_TechCarving3,
	eImage_TechCarving4,
	eImage_TechCarving5,
	eImage_TechCarving6,
	eImage_FamilyTreeArrowUp,
	eImage_FamilyTreeArrowDown,
	eImage_OrangeButton,
	eImage_AwardsBG,
	eImage_AchievementScrollKnobTop,
	eImage_AchievementScrollKnobMid,
	eImage_AchievementScrollKnobBtm,
	eImage_AchievementTopUI,
	eImage_AchievementBottomUI,
	eImage_AchievementStar,
	eImage_AchievementBox,
	eImage_AchievementProgressBox,
	eImage_AchievementProgressBox2,
	eImage_AchievementArrowUp,
	eImage_AchievementArrowDown,
	eImage_ButterflyGreen,
	eImage_MainWideButton,
	eImage_UltraWideButton,
	eImage_MainSceneButton1,
	eImage_MainSceneButton2,
	eImage_MainSceneButton3,
	eImage_MainSceneButton4,
	eImage_MainDetailButton,
	eImage_MainDetailLeftButton,	
	eImage_MainDetailRightButton,
	eImage_MainCollectionButton, 
	eImage_MainTrophyButton, 		
	eImage_MainPuzzleButton, 		
	eImage_MainMapButton, 		
	eImage_MainTechButton, 		
	eImage_MainMenuButton, 		
	eImage_MainMenuChangeTribeButton,	
	eImage_MainMenuHelpButton,
	eImage_MainMenuOptionsButton,	
	eImage_MainMenuPlayButton,	
	eImage_MainMenuQuitButton,	
	eImage_MainMenuStartOverButton,	
	eImage_DialogButton,
	eImage_DialogTilesOrange,	
	eImage_DialogTilesGreen,	
	eImage_LeftArrowButton,
	eImage_RightArrowButton,
	eImage_RadioButton,
	eImage_RadioButtonOff,	
	eImage_RadioButtonOn,	
	eImage_CheckBox,
	eImage_CheckMark,		
	eImage_SliderFrame,		
	eImage_SliderHandle,
	eImage_ScrollUpArrow,		
	eImage_ScrollDownArrow,	
	eImage_ScrollVerticalTrack,
	eImage_ScrollVerticalKnob,
	eImage_BamboMeterFrame,
	eImage_StatusBarSliceB,
	eImage_StatusBarSliceR,
	eImage_BlueStatusBarGlow,
	eImage_Canopy,
	eImage_DustStrip,
	eImage_LabStatesStrip,
	eImage_DoctorNecklacePiece,
	eImage_FarmerNecklacePiece,
	eImage_BuilderNecklacePiece,
	eImage_ScientistNecklacePiece,
	eImage_CompletedNecklace,
	eImage_BuilderPuzzleStrip,
	eImage_IdolStatesStrip,
	eImage_InvertedLightBeam,
	eImage_InvertedLightBeamSingleCenter,
	eImage_StatusBulb,
	eImage_MeterSlice,		
	eImage_FocusCircle,
	eImage_OverviewBG,
	eImage_OverviewCloud,
	eImage_OverviewCloud1,
	eImage_OverviewCloud2,
	eImage_OverviewCloud3,
	eImage_DarkCloud1,
	eImage_DarkCloud2,
	eImage_LoadingBG,
	eImage_LdwLogo,			
	eImage_Logo,		
	eImage_SmallLogo,		
	eImage_IntroPage1,
	eImage_IntroPage2,	
	eImage_IntroPage3,
	eImage_IntroPage5,
	eImage_IntroPage5Mask,
	eImage_MidGamePage1,
	eImage_MidGamePage2,
	eImage_MidGamePage3,
	eImage_MidGamePage4,
	eImage_MidGamePage5,
	eImage_EndGamePage1,
	eImage_EndGamePage2,	
	eImage_EndGamePage3,
	eImage_MainBG,
	eImage_MainUITopBar,
	eImage_PuzzlesBG,
	eImage_PuzzlesPicsBG,
	eImage_Help1,		
	eImage_Help2,		
	eImage_Help3,		
	eImage_Help4,		
	eImage_Credits,
	eImage_MenuBG,	
	eImage_Empty,			
	eImage_ArrowUpGlow,		
	eImage_ArrowDownGlow,	
	eImage_ArrowLeftGlow,	
	eImage_ArrowRightGlow,
	eImage_PuzzleCover,		
	eImage_CollectionBG,
	eImage_CollectingFishScales,
	eImage_CollectingLabPieces,
	eImage_CollectingMausoleum,
	eImage_CollectingFlutes,
	eImage_TechBG,			
	eImage_Science,			
	eImage_Medicine,		
	eImage_Learning,
	eImage_Restoration,
	eImage_Farming,
	eImage_Evangelism,
	eImage_BuyButton,
	eImage_InfoButton,
	eImage_VDSceneMeterDetail,
	eImage_TechSceneGodPowerOn,
	eImage_TechSceneGodPowerOff,
	eImage_TechSceneGodPowerBg,
	eImage_TechSceneGodPowerCover,
	eImage_VillagerBG,		
	eImage_HospitalStates,
	eImage_FoodBin,
	eImage_GranaryStagesStrip,
	eImage_blinkEyesMaskStrip,
	eImage_blinkEyesMaskStripSm,
	eImage_PondStrip,
	eImage_Waves,
	eImage_YellowSparkle,
	eImage_SparkleStrip2,
	eImage_SparkleStrip,
	eImage_Dust,
	eImage_Algae,
	eImage_Rainbow,
	eImage_Bubble,
	eImage_CandleStrip,
	eImage_FrogStrip,
	eImage_FrogStrip2,
	eImage_Fire,
	eImage_PetalStrip,
	eImage_LeafStrip,
	eImage_Foam,
	eImage_Carrying,
	eImage_Spray,
	eImage_SharpSparkle,
	eImage_BlurrySparkle,
	eImage_Collectables,
	eImage_Footprints,
	eImage_Raindrops,
	eImage_SmokeStrip,
	eImage_DarkSmokeStrip,
	eImage_ReefFish1,
	eImage_ReefFish2,
	eImage_ReefFish3,
	eImage_SwarmOfBees,
	eImage_FishFlopAnim,
	eImage_Bubblestrip,
	eImage_AmpPuddle,
	eImage_WoodPile,
	eImage_Scaffolding,
	eImage_Grave,
	eImage_FireStrip,		
	eImage_FemaleHeads,	
	eImage_FemaleBodies,	
	eImage_FemaleActions,	
	eImage_MaleHeads,		
	eImage_MaleBodies,	
	eImage_MaleActions,	
	eImage_HiResHeads,	
	eImage_HiResBodies,	
	eImage_HeathenMasks,
	eImage_VillagerShadow,
	eImage_Skelly,		
	eImage_Ripple,		
	eImage_Sunbeam,		
	eImage_Fog,
	eImage_HutStates,
	eImage_ClothingHutStates,		
	eImage_LoveShackStates,
	eImage_NurseryHutStates,
	eImage_HospitalHutStates,
	eImage_Bird,			
	eImage_BirdShadow,	
	eImage_Dragonflies,
	eImage_HummingBirds,
	eImage_RockSlide,
	eImage_RockSlide2,
	eImage_Aqueduct1,
	eImage_Aqueduct2,
	eImage_Aqueduct3,
	eImage_FieldAlive,
	eImage_FieldDead,
	eImage_Crops,
	eImage_LakePuddles,
	eImage_LakeFull,
	eImage_FlyingFish1,
	eImage_FlyingFish2,
	eImage_Pollen,
	eImage_TopWaterfall,
	eImage_MiddleWaterfall,
	eImage_BottomWaterfall,
	eImage_BridgeWater,

	eImage_Collectable01,
	eImage_Collectable02,
	eImage_Collectable03,
	eImage_Collectable04,
	eImage_Collectable05,
	eImage_Collectable06,
	eImage_Collectable07,
	eImage_Collectable08,
	eImage_Collectable09,
	eImage_Collectable10,
	eImage_Collectable11,
	eImage_Collectable12,
	eImage_Collectable13,
	eImage_Collectable14,
	eImage_Collectable15,
	eImage_Collectable16,
	eImage_Collectable17,
	eImage_Collectable18,
	eImage_Collectable19,
	eImage_Collectable20,
	eImage_Collectable21,
	eImage_Collectable22,
	eImage_Collectable23,
	eImage_Collectable24,
	eImage_Collectable25,
	eImage_Collectable26,
	eImage_Collectable27,
	eImage_Collectable28,
	eImage_Collectable29,
	eImage_Collectable30,
	eImage_Collectable31,
	eImage_Collectable32,
	eImage_Collectable33,
	eImage_Collectable34,
	eImage_Collectable35,
	eImage_Collectable36,
	eImage_Collectable37,
	eImage_Collectable38,
	eImage_Collectable39,
	eImage_Collectable40,
	eImage_Collectable41,
	eImage_Collectable42,
	eImage_Collectable43,
	eImage_Collectable44,
	eImage_Collectable45,
	eImage_Collectable46,
	eImage_Collectable47,
	eImage_Collectable48,

	eImage_Necklace01,
	eImage_Necklace02,
	eImage_Necklace03,
	eImage_Necklace04,

	eImage_Eye,
	eImage_Pupil,

	eImage_BonusPuzzleNotSolved,
	eImage_BonusPuzzleSolved,

	eImage_NumberOf
};

class theGraphicsManagerImpl;
class ldwGameWindow;

class theGraphicsManager
{
public:

	static theGraphicsManager *Get();
	static void Destroy();

	ldwImage      *GetImage(EImage imageId);
	ldwImageStrip *GetImageStrip(EImage imageId);
	ldwImageGrid  *GetImageGrid(EImage imageId);

	ldwImageGrid  *GetImageGridForCanvas(int canvas);
	ldwColor       GetTextColorForCanvas(int canvas);

	EImageType GetImageType(EImage imageId);
	int GetCellCount(EImage imageId);

	void ReleaseImage(EImage imageId,bool purge = false);

	void Draw(EImage imageId,int x = 0,int y = 0,float alpha = 1.0f,int scale = 100);
	void DrawCentered(EImage imageId,int x = 0,int y = 0,float alpha = 1.0f,int scale = 100);

	void DrawCell(EImage imageId, int cell, int x = 0, int y = 0,float alpha = 1.0f,int scale = 100);
	void DrawCellCentered(EImage imageId, int cell, int x = 0, int y = 0,float alpha = 1.0f,int scale = 100);

protected:
	
	static theGraphicsManager *mInstance;

	theGraphicsManager();
	~theGraphicsManager();

	theGraphicsManagerImpl *mGraphicsManager;

	ldwGameWindow *mGameWindow;
};

inline theGraphicsManager& GraphicsManager() {return *theGraphicsManager::Get();}

#endif